import 'package:eventpub/eventpub_response.dart';

import 'eventpub_interface.dart';

class MethodsEventpub extends EventHubInterface implements ResponseEvent {
  @override
  Map<String, dynamic> events = {};

  @override
  void dispatch(String event, Map<String, dynamic> data) {
    if (events[event] == null) {
      events[event] = {};
      events[event]["callbacks"] = [];
      events[event]["last"] = {};
    }

    List current = events[event]["callbacks"];
    events[event]["last"] = data;
    for (int i = 0; i < current.length; i++) {
      current[i]["cb"](data);
    }
  }

  @override
  String listen(String event, Function(Map<String, dynamic>) callback) {
    if (events[event] == null) {
      events[event] = {};
      events[event]["callbacks"] = [];
      events[event]["last"] = {};
    }

    List current = events[event]["callbacks"];
    String key = idGenerator();
    current.add({"key": key, "cb": callback});
    return key;
  }

  String idGenerator() {
    final now = DateTime.now();
    return now.microsecondsSinceEpoch.toString();
  }

  @override
  Map<String, dynamic> getEvent(String event) {
    Map<String, dynamic> res = events[event]?["last"] ?? {};
    return res;
  }

  @override
  void dispose(String event, String id) {
    List ev = events[event]["callbacks"];
    ev.removeWhere((el) {
      return el["key"].toString().compareTo(id) == 0;
    });
    events[event]["callbacks"] = ev;
  }

  @override
  void disposeAll(String event) {
    events[event]["callbacks"] = [];
  }
}
